package net.bjoerks.ListeDemo;

import java.util.ArrayList;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public /*static*/ class ListeDemoEfficientAdapter extends BaseAdapter {
    private LayoutInflater mInflater;

	private ArrayList<DemoItem> items;

	    public ListeDemoEfficientAdapter(Context context) {
		this.items =  MainViewModel.getMainViewModel().items;
        // Cache the LayoutInflate to avoid asking for a new one each time.
        mInflater = LayoutInflater.from(context);

        // Icons bound to the rows.
//        mIcon1 = BitmapFactory.decodeResource(context.getResources(), R.drawable.icon48x48_1);
 //       mIcon2 = BitmapFactory.decodeResource(context.getResources(), R.drawable.icon48x48_2);
    }

    /**
     * The number of items in the list is determined by the number of speeches
     * in our array.
     *
     * @see android.widget.ListAdapter#getCount()
     */
    public int getCount() {
        return items.size();
    }

    /**
     * Since the data comes from an array, just returning the index is
     * sufficent to get at the data. If we were using a more complex data
     * structure, we would return whatever object represents one row in the
     * list.
     *
     * @see android.widget.ListAdapter#getItem(int)
     */
    public Object getItem(int position) {
        return position;
    }

    /**
     * Use the array index as a unique id.
     *
     * @see android.widget.ListAdapter#getItemId(int)
     */
    public long getItemId(int position) {
        return position;
    }

    /**
     * Make a view to hold each row.
     *
     * @see android.widget.ListAdapter#getView(int, android.view.View,
     *      android.view.ViewGroup)
     */
    public View getView(int position, View convertView, ViewGroup parent) {
        // A ViewHolder keeps references to children views to avoid unneccessary calls
        // to findViewById() on each row.
        // Bind the data efficiently with the holder.
        DemoItem item = items.get(position);
        boolean buffered = true;
        boolean stateChanged = false;

    	ViewHolder holder;

    	if (convertView != null) {
            // Get the ViewHolder back to get fast access to the TextView
            // and the ImageView.
            holder = (ViewHolder) convertView.getTag();
    	}
        // When convertView is not null, we can reuse it directly, there is no need
        // to reinflate it. We only inflate a new View when the convertView supplied
        // by ListView is null.
        if (convertView == null) {
    		convertView = mInflater.inflate(R.layout.demolistitem, null);
        	
            // Creates a ViewHolder and store references to the two children views
            // we want to bind data to.
            holder = new ViewHolder();
            holder.image = (ImageView) convertView.findViewById(R.id.listelm_image);
            holder.date = (TextView) convertView.findViewById(R.id.listelm_date);
            holder.title = (TextView) convertView.findViewById(R.id.listelm_title);
            holder.webViewImage = (WebView) convertView.findViewById(R.id.listelm_webImageView);

            convertView.setTag(holder);
        } else {
            // Get the ViewHolder back to get fast access to the TextView
            // and the ImageView.
            holder = (ViewHolder) convertView.getTag();
        }

        // Bind the data efficiently with the holder.

//        holder.image.setImageURI(Uri.parse("file:///android_asset/eal.png"));
//        holder.image.setImageBitmap(BitmapFactory.decodeFile("file:///android_asset/eal.png"));
        if (item.ItemImagesBitmap != null)
        	holder.image.setImageBitmap(item.ItemImagesBitmap);
//        else if (item.ItemImagesDrawable != null)
//        	holder.image.setImageDrawable(item.ItemImagesDrawable);
        else 
        	holder.image.setImageResource(R.drawable.liste_demo);
        holder.date.setText(item.Date);
        holder.title.setText(item.Title);
        
        if (position<5){
            // Lidt forskellige test!!!
        	String html = "<html><body><p><img border=\"0\" src=\"http://bjoerks.net/cv/bjbu8.jpg\" height=\"90\"></p></body></html>";
            if (item.WebImagesUrl.length()>0)
            	html = html.replace("http://bjoerks.net/cv/bjbu8.jpg", item.WebImagesUrl);
            if (position == 4){		//test url
            	html = "<html><body><p>Her er ingen billede men en web tekst</p></body></html>";
            }

            String mimeType = "text/html";
	        String encoding = "utf-8";
	        holder.webViewImage.loadData(html, mimeType, encoding);
        	
        }
        else {
//        	holder.webViewImage.loadUrl("http://www.google.com");
        }

        return convertView;
    }

    static class ViewHolder {
    	ImageView image;
    	TextView date;
        TextView title;
        WebView webViewImage;
    }
}

